Index: /java/main/src/main/java/com/framsticks/communication/queries/CallRequest.java
===================================================================
--- /java/main/src/main/java/com/framsticks/communication/queries/CallRequest.java	(revision 95)
+++ /java/main/src/main/java/com/framsticks/communication/queries/CallRequest.java	(revision 96)
@@ -1,6 +1,9 @@
 package com.framsticks.communication.queries;
 
-import com.framsticks.communication.Request;
+import com.framsticks.util.Misc;
+import com.framsticks.util.lang.Pair;
 
+import java.util.ArrayList;
+import java.util.Collection;
 import java.util.List;
 
@@ -10,23 +13,42 @@
 public class CallRequest extends ApplicationRequest {
 
-	protected String arguments;
-	protected String method;
+	protected final List<Object> arguments = new ArrayList<>();
+	protected String procedure;
 
-	public CallRequest setArguments(String arguments) {
-		this.arguments = arguments;
+	public CallRequest addArguments(String arguments) {
+		// this.arguments = arguments;
 		return this;
 	}
 
-	public CallRequest setArguments(List<String> arguments) {
-		StringBuilder buffer = new StringBuilder();
-		for (String a : arguments) {
-			buffer.append(" ");
-			Request.quoteValue(buffer, a.trim());
-		}
-		return this.setArguments(buffer.toString());
+	/**
+	 * @return the arguments
+	 */
+	public List<Object> getArguments() {
+		return arguments;
 	}
 
-	public CallRequest setMethod(String method) {
-		this.method = method;
+	/**
+	 * @return the procedure
+	 */
+	public String getProcedure() {
+		return procedure;
+	}
+
+	/**
+	 * @param arguments the arguments to set
+	 */
+	public CallRequest arguments(Collection<Object> arguments) {
+		this.arguments.clear();
+		this.arguments.addAll(arguments);
+		return this;
+	}
+
+	public CallRequest argument(Object argument) {
+		arguments.add(argument);
+		return this;
+	}
+
+	public CallRequest procedure(String procedure) {
+		this.procedure = procedure;
 		return this;
 	}
@@ -35,9 +57,9 @@
 	protected StringBuilder construct(StringBuilder buffer) {
 		super.construct(buffer);
-		if (method != null) {
-			buffer.append(" ").append(method);
-		}
-		if (arguments != null) {
-			buffer.append(arguments);
+		Misc.throwIfNull(procedure);
+		buffer.append(' ').append(procedure);
+		for (Object arg : arguments) {
+			buffer.append(' ');
+			quoteArgumentIfNeeded(buffer, arg);
 		}
 		return buffer;
@@ -49,3 +71,14 @@
 	}
 
+	@Override
+	public CharSequence parseRest(CharSequence rest) {
+		rest = super.parseRest(rest);
+		Pair<CharSequence, CharSequence> p = Misc.throwIfNull(takeIdentifier(rest));
+		this.procedure = p.first.toString();
+		while ((p = takeString(p.second)) != null) {
+			arguments.add(p.first);
+		}
+		return null;
+	}
+
 }
Index: /java/main/src/main/java/com/framsticks/communication/queries/GetRequest.java
===================================================================
--- /java/main/src/main/java/com/framsticks/communication/queries/GetRequest.java	(revision 95)
+++ /java/main/src/main/java/com/framsticks/communication/queries/GetRequest.java	(revision 96)
@@ -1,3 +1,9 @@
 package com.framsticks.communication.queries;
+
+import java.util.ArrayList;
+import java.util.List;
+
+import com.framsticks.util.lang.Delimeted;
+import com.framsticks.util.lang.Pair;
 
 /**
@@ -5,5 +11,19 @@
  */
 public class GetRequest extends ApplicationRequest {
+	protected final List<String> fields = new ArrayList<>();
+
 	public GetRequest() {
+	}
+
+	public GetRequest fields(List<String> fields) {
+		this.fields.clear();
+		this.fields.addAll(fields);
+		return this;
+	}
+
+	public GetRequest field(String field) {
+		this.fields.clear();
+		this.fields.add(field);
+		return this;
 	}
 
@@ -12,3 +32,31 @@
 		return "get";
 	}
+
+	@Override
+	protected StringBuilder construct(StringBuilder buffer) {
+		super.construct(buffer);
+		if (!fields.isEmpty()) {
+			buffer.append(' ').append(new Delimeted<String>(",", "").append(fields.iterator()));
+		}
+		return buffer;
+	}
+
+	/**
+	 * @return the fields
+	 */
+	public List<String> getFields() {
+		return fields;
+	}
+
+	@Override
+	public CharSequence parseRest(CharSequence rest) {
+		rest = super.parseRest(rest);
+		Pair<CharSequence, CharSequence> p = takeIdentifier(rest);
+		if (p != null) {
+			for (String a : p.first.toString().split(",")) {
+				fields.add(a);
+			}
+		}
+		return null;
+	}
 }
Index: /java/main/src/main/java/com/framsticks/communication/queries/SetRequest.java
===================================================================
--- /java/main/src/main/java/com/framsticks/communication/queries/SetRequest.java	(revision 95)
+++ /java/main/src/main/java/com/framsticks/communication/queries/SetRequest.java	(revision 96)
@@ -1,3 +1,5 @@
 package com.framsticks.communication.queries;
+
+import com.framsticks.util.lang.Pair;
 
 /**
@@ -5,7 +7,14 @@
  */
 public class SetRequest extends ApplicationRequest {
+
+	protected String field;
 	protected String value;
 
 	public SetRequest() {
+	}
+
+	public SetRequest field(String field) {
+		this.field = field;
+		return this;
 	}
 
@@ -17,13 +26,35 @@
 	@Override
 	protected StringBuilder construct(StringBuilder buffer) {
-		super.construct(buffer);
-		if (value != null) {
-			buffer.append(" \"").append(value).append("\"");
-		}
-		return buffer;
+		return quoteArgumentIfNeeded(super.construct(buffer).append(' ').append(field).append(' '), value);
 	}
+
 	@Override
 	public String getCommand() {
 		return "set";
 	}
+
+
+	@Override
+	public CharSequence parseRest(CharSequence rest) {
+		final Pair<CharSequence, CharSequence> fp = takeString(super.parseRest(rest));
+		field = fp.first.toString();
+		final Pair<CharSequence, CharSequence> vp = takeString(fp.second);
+		value = vp.first.toString();
+
+		return vp.second;
+	}
+
+	/**
+	 * @return the field
+	 */
+	public String getField() {
+		return field;
+	}
+
+	/**
+	 * @return the value
+	 */
+	public String getValue() {
+		return value;
+	}
 }
Index: /java/main/src/main/java/com/framsticks/communication/queries/UseRequest.java
===================================================================
--- /java/main/src/main/java/com/framsticks/communication/queries/UseRequest.java	(revision 95)
+++ /java/main/src/main/java/com/framsticks/communication/queries/UseRequest.java	(revision 96)
@@ -1,3 +1,5 @@
 package com.framsticks.communication.queries;
+
+import com.framsticks.util.lang.Strings;
 
 /**
@@ -19,10 +21,12 @@
 	@Override
 	protected StringBuilder construct(StringBuilder buffer) {
-		return buffer.append(' ').append(feature);
+		return buffer.append(feature);
 	}
 
 	@Override
-	public void parseRest(String rest) {
-		feature = rest;
+	public CharSequence parseRest(CharSequence rest) {
+		feature = rest.toString();
+		Strings.assureNotEmpty(feature);
+		return null;
 	}
 
Index: /java/main/src/main/java/com/framsticks/communication/queries/VersionRequest.java
===================================================================
--- /java/main/src/main/java/com/framsticks/communication/queries/VersionRequest.java	(revision 95)
+++ /java/main/src/main/java/com/framsticks/communication/queries/VersionRequest.java	(revision 96)
@@ -23,11 +23,12 @@
 
 	@Override
-	public void parseRest(String rest) {
-		version = Numbers.parse(rest, Integer.class);
+	public CharSequence parseRest(CharSequence rest) {
+		version = Numbers.parse(rest.toString(), Integer.class);
+		return null;
 	}
 
 	@Override
 	protected StringBuilder construct(StringBuilder buffer) {
-		return buffer.append(' ').append(version);
+		return buffer.append(version);
 	}
 
Index: /java/main/src/main/java/com/framsticks/communication/util/LoggingStateCallback.java
===================================================================
--- /java/main/src/main/java/com/framsticks/communication/util/LoggingStateCallback.java	(revision 95)
+++ /java/main/src/main/java/com/framsticks/communication/util/LoggingStateCallback.java	(revision 96)
@@ -2,4 +2,6 @@
 
 import com.framsticks.communication.StateCallback;
+import com.framsticks.util.FramsticksException;
+
 import org.apache.log4j.Logger;
 
@@ -18,9 +20,10 @@
 
 	@Override
-	public void call(Exception e) {
-		if (e != null) {
-			logger.error("failed to " + message + " with " + e);
-			return;
-		}
+	public void handle(FramsticksException e) {
+		logger.error("failed to " + message + " with " + e);
+	}
+
+	@Override
+	public void callImpl() {
 		logger.debug(message);
 	}
Index: /java/main/src/main/java/com/framsticks/core/AbstractInstance.java
===================================================================
--- /java/main/src/main/java/com/framsticks/core/AbstractInstance.java	(revision 96)
+++ /java/main/src/main/java/com/framsticks/core/AbstractInstance.java	(revision 96)
@@ -0,0 +1,162 @@
+package com.framsticks.core;
+import java.util.HashSet;
+import java.util.Set;
+
+import javax.annotation.Nonnull;
+
+import org.apache.log4j.Logger;
+
+import com.framsticks.params.AccessInterface;
+import com.framsticks.params.CompositeParam;
+import com.framsticks.params.FramsClass;
+import com.framsticks.params.Param;
+import com.framsticks.params.ParamsPackage;
+import com.framsticks.params.Registry;
+import com.framsticks.params.annotations.AutoAppendAnnotation;
+import com.framsticks.params.annotations.FramsClassAnnotation;
+import com.framsticks.util.dispatching.Dispatching;
+import com.framsticks.util.dispatching.RunAt;
+import com.framsticks.util.dispatching.Thread;
+// import static com.framsticks.core.InstanceUtils.*;
+
+/**
+ * @author Piotr Sniegowski
+ */
+@FramsClassAnnotation
+public abstract class AbstractInstance extends Thread<Instance> implements Instance {
+
+	private static final Logger log = Logger.getLogger(Instance.class);
+
+	private Node root;
+
+	@Override
+	public void setRoot(Node node) {
+		root = node;
+	}
+
+	@Override
+	public @Nonnull Node getRoot() {
+		assert root != null;
+		return root;
+	}
+
+	public boolean isRootAssigned() {
+		// assert isActive();
+		return root != null;
+	}
+
+	protected Set<InstanceListener> listeners = new HashSet<InstanceListener>();
+
+	public AbstractInstance() {
+		setName("entity");
+	}
+
+	protected void tryRegisterOnChangeEvents(Path path) {
+
+	}
+
+
+	protected void fireRun(Exception e) {
+		for (InstanceListener l : this.listeners) {
+			l.onRun(e);
+		}
+	}
+
+	protected void fireStop(Exception e) {
+		for (InstanceListener l : this.listeners) {
+			l.onStop(e);
+		}
+	}
+
+	@Override
+	public void addListener(final InstanceListener listener) {
+		assert Dispatching.isThreadSafe();
+		Dispatching.dispatchIfNotActive(this, new RunAt<Instance>() {
+			@Override
+			public void run() {
+				listeners.add(listener);
+			}
+		});
+	}
+
+	@Override
+	public void removeListener(final InstanceListener listener) {
+		assert Dispatching.isThreadSafe();
+		Dispatching.dispatchIfNotActive(this, new RunAt<Instance>() {
+			@Override
+			public void run() {
+				listeners.remove(listener);
+			}
+		});
+	}
+
+	protected void fireListChange(Path path, ListChange change) {
+		assert isActive();
+		for (InstanceListener l : this.listeners) {
+			l.onListChange(path, change);
+		}
+	}
+
+	@Override
+	public void notifyOfFetch(Path path) {
+		fireFetch(path);
+	}
+
+	protected void fireFetch(Path path) {
+		assert isActive();
+		for (InstanceListener l : this.listeners) {
+			l.onFetch(path);
+		}
+	}
+
+
+	@Override
+	public final FramsClass getInfoFromCache(String id) {
+		assert isActive();
+		return registry.getFramsClass(id);
+	}
+
+	protected Registry registry = new Registry();
+
+
+	@Override
+	public @Nonnull AccessInterface prepareAccess(CompositeParam param) {
+		return registry.prepareAccess(param);
+	}
+
+	@Override
+	public void takeAllFrom(Registry source) {
+		registry.takeAllFrom(source);
+	}
+
+	@AutoAppendAnnotation
+	public void usePackage(ParamsPackage paramsPackage) {
+		log.debug("using package " + paramsPackage + " in instance " + this);
+		paramsPackage.register(registry);
+	}
+
+	@AutoAppendAnnotation
+	public void takeFromRegistry(Registry registry) {
+		log.debug("taking from registry " + registry + " in instance " + this);
+		this.registry.takeAllFrom(registry);
+	}
+
+	@Override
+	protected void joinableStart() {
+		dispatch(new RunAt<Instance>() {
+			@Override
+			public void run() {
+				if (!isRootAssigned()) {
+					setRoot(new Node(Param.build().name("Instance").id(getName()).type("o").finish(CompositeParam.class), null));
+				}
+			}
+		});
+		super.joinableStart();
+	}
+
+	@Override
+	public void putInfoIntoCache(FramsClass framclass) {
+		registry.putFramsClass(framclass);
+	}
+}
+
Index: /java/main/src/main/java/com/framsticks/core/Framsticks.java
===================================================================
--- /java/main/src/main/java/com/framsticks/core/Framsticks.java	(revision 95)
+++ /java/main/src/main/java/com/framsticks/core/Framsticks.java	(revision 96)
@@ -3,4 +3,5 @@
 import com.framsticks.params.annotations.FramsClassAnnotation;
 import com.framsticks.parsers.XmlLoader;
+import com.framsticks.util.dispatching.Joinable;
 import com.framsticks.util.dispatching.JoinableCollection;
 import com.framsticks.util.dispatching.Monitor;
@@ -15,5 +16,5 @@
  */
 @FramsClassAnnotation
-public class Framsticks extends JoinableCollection<Entity> {
+public class Framsticks extends JoinableCollection<Joinable> {
 	private static final Logger log = Logger.getLogger(Framsticks.class);
 
@@ -28,11 +29,7 @@
 	public static void main(final String[] args) {
 
-		new Monitor(loadConfiguration(Framsticks.class.getResourceAsStream("/configs/framsticks.xml")))
-			.use()
-			.waitFor()
-			.drop()
-			.join();
+		new Monitor(loadConfiguration(Framsticks.class.getResourceAsStream("/configs/framsticks.xml"))).use().waitFor().drop().join();
 
-		log.info("exiting main");
+		log.debug("exiting main");
 	}
 
Index: /java/main/src/main/java/com/framsticks/core/Instance.java
===================================================================
--- /java/main/src/main/java/com/framsticks/core/Instance.java	(revision 95)
+++ /java/main/src/main/java/com/framsticks/core/Instance.java	(revision 96)
@@ -1,420 +1,55 @@
 package com.framsticks.core;
-
-import java.util.HashSet;
-import java.util.Iterator;
-import java.util.LinkedList;
-import java.util.List;
-import java.util.Set;
 
 import javax.annotation.Nonnull;
 
-import org.apache.log4j.Logger;
-
-import com.framsticks.communication.File;
 import com.framsticks.params.AccessInterface;
 import com.framsticks.params.CompositeParam;
-import com.framsticks.params.ConstructionException;
 import com.framsticks.params.FramsClass;
-import com.framsticks.params.ListAccess;
-import com.framsticks.params.Param;
-import com.framsticks.params.ParamsPackage;
 import com.framsticks.params.Registry;
 import com.framsticks.params.ValueParam;
-import com.framsticks.params.annotations.AutoAppendAnnotation;
-import com.framsticks.params.annotations.FramsClassAnnotation;
-import com.framsticks.params.types.ObjectParam;
 import com.framsticks.params.types.ProcedureParam;
-import com.framsticks.parsers.Loaders;
-import com.framsticks.parsers.MultiParamLoader;
-import com.framsticks.util.FramsticksException;
 import com.framsticks.util.StateFunctor;
-import com.framsticks.util.UnsupportedOperationException;
-import com.framsticks.util.dispatching.Dispatching;
+import com.framsticks.util.dispatching.Dispatcher;
 import com.framsticks.util.dispatching.Future;
-import com.framsticks.util.dispatching.RunAt;
-import com.framsticks.util.dispatching.Thread;
-import com.framsticks.util.lang.Casting;
+import com.framsticks.util.dispatching.Joinable;
 
-/**
- * @author Piotr Sniegowski
- */
-@FramsClassAnnotation
-public abstract class Instance extends Thread<Instance> implements Entity {
+public interface Instance extends Dispatcher<Instance>, Joinable {
 
-	private static final Logger log = Logger.getLogger(Instance.class.getName());
+	public @Nonnull Node getRoot();
+	public @Nonnull void setRoot(Node node);
 
-	private Node root;
+	public @Nonnull AccessInterface prepareAccess(CompositeParam param);
+	public void takeAllFrom(Registry source);
 
-	protected @Nonnull Node setRoot(CompositeParam param, Object object) {
-		// if (isRootAssigned()) {
-		// 	throw new FramsticksException().msg("root is already assigned");
-		// }
-		// assert isActive();
-		root = new Node(param, object);
-		return root;
-	}
+	public void addListener(InstanceListener listener);
+	public void removeListener(InstanceListener listener);
 
-	protected @Nonnull Node getRoot() {
-		// assert isActive();
-		assert root != null;
-		return root;
-	}
+	public void notifyOfFetch(Path path);
 
-	public boolean isRootAssigned() {
-		// assert isActive();
-		return root != null;
-	}
+	public FramsClass getInfoFromCache(String id);
 
-	protected Set<InstanceListener> listeners = new HashSet<InstanceListener>();
+	public void putInfoIntoCache(FramsClass framclass);
 
-	public Instance() {
-		setName("entity");
-	}
-
-	protected void fetchInfo(Path path, Future<FramsClass> future) {
-		future.result(null, new UnsupportedOperationException());
-	}
-
-	public void resolve(Path path, Future<Path> future) {
-		assert isActive();
-		assert path.isOwner(this);
-		if (path.getTop().getObject() != null) {
-			future.result(path, null);
-			return;
-		}
-		AccessInterface access = bindAccess(path.getUnder());
-		Object object = access.get(path.getTop().getParam(), Object.class);
-		if (object == null) {
-			future.result(path, null);
-			return;
-		}
-		future.result(path.appendResolution(object), null);
-	}
+	public void resolve(Path path, Future<Path> future);
 
 	/** This is part of the Instance interface.
 	 *
 	 */
-	public abstract void fetchValue(Path path, Param param, StateFunctor stateFunctor);
+	public void fetchValue(Path path, ValueParam param, StateFunctor stateFunctor);
 
 	/** This is part of the Instance interface.
 	 *
 	 */
-	public abstract void fetchValues(Path path, StateFunctor stateFunctor);
+	public void fetchValues(Path path, StateFunctor stateFunctor);
 
 	/** This is part of the Instance interface.
 	 *
 	 */
-	public abstract void call(Path path, ProcedureParam param, Object[] arguments, StateFunctor stateFunctor);
+	public void call(Path path, ProcedureParam param, Object[] arguments, Future<Object> future);
 
-	protected void tryRegisterOnChangeEvents(Path path) {
+	public void storeValue(Path path, ValueParam param, Object value, StateFunctor stateFunctor);
 
-	}
+	public void fetchInfo(Path path, Future<FramsClass> future);
 
-	public void storeValue(Path path, Param param, Object value, final StateFunctor stateFunctor) {
-		assert isActive();
-		dispatch(new RunAt<Instance>() {
-			@Override
-			public void run() {
-				stateFunctor.call(new UnsupportedOperationException());
-			}
-		});
-	}
-
-	protected void fireRun(Exception e) {
-		for (InstanceListener l : this.listeners) {
-			l.onRun(e);
-		}
-	}
-
-	protected void fireStop(Exception e) {
-		for (InstanceListener l : this.listeners) {
-			l.onStop(e);
-		}
-	}
-
-	public void addListener(final InstanceListener listener) {
-		assert Dispatching.isThreadSafe();
-		Dispatching.dispatchIfNotActive(this, new RunAt<Instance>() {
-			@Override
-			public void run() {
-				listeners.add(listener);
-			}
-		});
-	}
-
-	public void removeListener(final InstanceListener listener) {
-		assert Dispatching.isThreadSafe();
-		Dispatching.dispatchIfNotActive(this, new RunAt<Instance>() {
-			@Override
-			public void run() {
-				listeners.remove(listener);
-			}
-		});
-	}
-
-	protected void fireListChange(Path path, ListChange change) {
-		assert isActive();
-		for (InstanceListener l : this.listeners) {
-			l.onListChange(path, change);
-		}
-	}
-
-	protected void fireFetch(Path path) {
-		assert isActive();
-		for (InstanceListener l : this.listeners) {
-			l.onFetch(path);
-		}
-	}
-
-	public final FramsClass getInfoFromCache(Path path) {
-		return getInfoFromCache(path.getTop().getParam().getContainedTypeName());
-	}
-
-	public FramsClass getInfoFromCache(String id) {
-		assert isActive();
-		return registry.getFramsClass(id);
-	}
-
-	protected Registry registry = new Registry();
-
-	public AccessInterface createAccess(String name) throws ConstructionException {
-		assert isActive();
-		return registry.createAccess(name);
-	}
-
-	// TODO: make ValueParam
-	public <T> T get(Node node, Param childParam, Class<T> type) {
-		return bindAccess(node).get((ValueParam) childParam, type);
-	}
-
-	public void findInfo(final Path path, final Future<FramsClass> future) {
-		assert isActive();
-		final String name = path.getTop().getParam().getContainedTypeName();
-		final FramsClass framsClass = getInfoFromCache(name);
-		if (framsClass != null) {
-			log.trace("info for " + name + " found in cache");
-			future.result(framsClass, null);
-			return;
-		}
-		fetchInfo(path, future);
-	}
-
-	public final AccessInterface bindAccess(String path) {
-		return bindAccess(getPath(path));
-	}
-
-	public final AccessInterface bindAccess(Node node) {
-		assert isActive();
-		assert node.getObject() != null;
-
-		try {
-			AccessInterface access = registry.prepareAccess(node.getParam());
-			if (access == null) {
-				throw new FramsticksException().msg("failed to prepare access for param").arg("param", node.getParam());
-			}
-			return access.select(node.getObject());
-		} catch (ConstructionException e) {
-			log.error("failed to bind access for " + node.getParam() + ": " + e);
-		}
-		return null;
-	}
-
-	public final <T> T getParam(Path path, String id, Class<T> type) {
-		return Casting.tryCast(type, registry.prepareAccess(path.getTop().getParam()).getParam(id));
-	}
-
-	public final AccessInterface bindAccess(Path path) {
-		path.assureResolved();
-		return bindAccess(path.getTop());
-	}
-
-	public void resolve(final String targetPath, final Future<Path> future) {
-		assert isActive();
-		final Path path = getPath(targetPath);
-		resolve(path, new Future<Path>() {
-			@Override
-			public void result(Path result, Exception e) {
-				assert isActive();
-				if (e != null) {
-					future.result(path, e);
-					return;
-				}
-				if (path.isResolved(targetPath)) {
-					future.result(path, null);
-					return;
-				}
-				if (path.isResolved()) {
-					future.result(path, new Exception("testing"));
-					return;
-				}
-				resolve(targetPath, future);
-			}
-		});
-	}
-
-	public void resolveAndFetch(final String targetPath, final Future<Path> future) {
-		assert isActive();
-		resolve(targetPath, new Future<Path>() {
-			@Override
-			public void result(final Path path, Exception e) {
-				if (e != null) {
-					future.result(path, e);
-					return;
-				}
-				assert path.isResolved(targetPath);
-				fetchValues(path, new StateFunctor() {
-					@Override
-					public void call(Exception e) {
-						future.result(path, e);
-					}
-				});
-			}
-		});
-	}
-
-	public Path createIfNeeded(String path) {
-		Path p;
-		while (!(p = getPath(path)).isResolved(path)) {
-			create(p);
-		}
-		return p;
-	}
-
-	public Path createIfNeeded(Path path) {
-		assert isActive();
-		if (path.isResolved()) {
-			return path;
-		}
-		return create(path);
-	}
-
-	public Path create(Path path) {
-		assert isActive();
-		assert !path.isResolved();
-		Path resolved = path.tryFindResolution();
-		if (!resolved.isResolved()) {
-			log.debug("creating: " + path);
-			AccessInterface access = registry.prepareAccess(path.getTop().getParam());
-			assert access != null;
-			Object child = access.createAccessee();
-			assert child != null;
-			if (path.size() == 1) {
-				setRoot(getRoot().getParam(), child);
-			} else {
-				bindAccess(path.getUnder()).set(path.getTop().getParam(), child);
-			}
-			resolved = path.appendResolution(child);
-		}
-		tryRegisterOnChangeEvents(resolved);
-		return resolved;
-	}
-
-
-
-
-	public @Nonnull FramsClass processFetchedInfo(File file) {
-		assert isActive();
-		FramsClass framsClass = Loaders.loadFramsClass(file.getContent());
-		if ("/".equals(file.getPath())) {
-			if (getRoot().getParam().getContainedTypeName() == null) {
-				setRoot(Param.build().name("Instance").id(getName()).type("o " + framsClass.getId()).finish(CompositeParam.class), getRoot().getObject());
-			}
-		}
-		registry.putFramsClass(framsClass);
-		return framsClass;
-	}
-
-	public void processFetchedValues(Path path, List<File> files) {
-		assert isActive();
-		assert files.size() == 1;
-		assert path.isTheSame(files.get(0).getPath());
-		Node node = path.getTop();
-		MultiParamLoader loader = new MultiParamLoader();
-		loader.setNewSource(files.get(0).getContent());
-		loader.addBreakCondition(MultiParamLoader.Status.AfterObject);
-
-		try {
-			if (node.getParam() instanceof ObjectParam) {
-				loader.addAccessInterface(bindAccess(node));
-				loader.go();
-				fireFetch(path);
-				return;
-			}
-
-			ListAccess listAccess = ((ListAccess)bindAccess(node));
-			assert listAccess != null;
-			listAccess.clearValues();
-
-			AccessInterface elementAccess = listAccess.getElementAccess();
-			loader.addAccessInterface(elementAccess);
-			MultiParamLoader.Status status;
-			while ((status = loader.go()) != MultiParamLoader.Status.Finished) {
-				if (status == MultiParamLoader.Status.AfterObject) {
-					AccessInterface accessInterface = loader.getLastAccessInterface();
-
-					String id = listAccess.computeIdentifierFor(accessInterface.getSelected());
-					//TODO listAccessParam
-					Param param = Param.build().forAccess(accessInterface).id(id).finish();
-					Object child = accessInterface.getSelected();
-					accessInterface.select(null);
-					assert child != null;
-					bindAccess(node).set((ValueParam) param, child);
-				}
-			}
-
-			fireFetch(path);
-		} catch (Exception e) {
-			log.error("exception occurred while loading: " + e);
-		}
-
-	}
-
-	public static Iterator<String> splitPath(String path) {
-		List<String> list = new LinkedList<String>();
-		for (String s : path.split("/")) {
-			if (!s.isEmpty()) {
-				list.add(s);
-			}
-		}
-		return list.iterator();
-	}
-
-	public Registry getRegistry() {
-		return registry;
-	}
-
-	public Path getPath(String textual) {
-		return Path.build().resolve(this, textual).finish();
-	}
-
-	public Path getRootPath() {
-		return getPath("/");
-	}
-
-	@AutoAppendAnnotation
-	public void usePackage(ParamsPackage paramsPackage) {
-		log.debug("using package " + paramsPackage + " in instance " + this);
-		paramsPackage.register(registry);
-	}
-
-	@AutoAppendAnnotation
-	public void takeFromRegistry(Registry registry) {
-		log.debug("taking from registry " + registry + " in instance " + this);
-		this.registry.takeAllFrom(registry);
-	}
-
-	@Override
-	protected void joinableStart() {
-		dispatch(new RunAt<Instance>() {
-			@Override
-			public void run() {
-				if (!isRootAssigned()) {
-					setRoot(Param.build().name("Instance").id(getName()).type("o").finish(CompositeParam.class), null);
-				}
-			}
-		});
-		super.joinableStart();
-	}
-
+	public Path create(Path path);
 }
-
